"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.FullStoryAPI = exports.getWindowFullStory = void 0;

var _react = require("react");

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var canUseDOM = !!(typeof window !== 'undefined' && window.document && window.document.createElement);

var getWindowFullStory = function getWindowFullStory() {
  return window[window['_fs_namespace']];
};

exports.getWindowFullStory = getWindowFullStory;

var FullStoryAPI = function FullStoryAPI(fn) {
  if (canUseDOM && getWindowFullStory()) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    getWindowFullStory()[fn].apply(null, args);
  } else {
    console.warn('FullStory not initialized yet');
  }
};

exports.FullStoryAPI = FullStoryAPI;

var FullStory =
/*#__PURE__*/
function (_Component) {
  _inherits(FullStory, _Component);

  function FullStory(props) {
    var _this;

    _classCallCheck(this, FullStory);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FullStory).call(this, props));
    var org = props.org,
        debug = props.debug,
        host = props.host,
        namespace = props.namespace;

    if (!org || !canUseDOM) {
      return _possibleConstructorReturn(_this);
    }

    if (!getWindowFullStory()) {
      window['_fs_debug'] = debug || false;
      window['_fs_host'] = host || 'fullstory.com';
      window['_fs_org'] = org;
      window['_fs_namespace'] = namespace || 'FS';

      (function (m, n, e, t, l, o, g, y) {
        if (e in m) {
          if (m.console && m.console.log) {
            m.console.log('FullStory namespace conflict. Please set window["_fs_namespace"].');
          }

          return;
        }

        g = m[e] = function (a, b, s) {
          g.q ? g.q.push([a, b, s]) : g._api(a, b, s);
        };

        g.q = [];
        o = n.createElement(t);
        o.async = 1;
        o.crossOrigin = 'anonymous';
        o.src = 'https://' + window['_fs_host'] + '/s/fs.js';
        y = n.getElementsByTagName(t)[0];
        y.parentNode.insertBefore(o, y);

        g.identify = function (i, v, s) {
          g(l, {
            uid: i
          }, s);
          if (v) g(l, v, s);
        };

        g.setUserVars = function (v, s) {
          g(l, v, s);
        };

        g.event = function (i, v, s) {
          g('event', {
            n: i,
            p: v
          }, s);
        };

        g.shutdown = function () {
          g('rec', !1);
        };

        g.restart = function () {
          g('rec', !0);
        };

        g.log = function (a, b) {
          g('log', [a, b]);
        };

        g.consent = function (a) {
          g('consent', !arguments.length || a);
        };

        g.identifyAccount = function (i, v) {
          o = 'account';
          v = v || {};
          v.acctId = i;
          g(o, v);
        };

        g.clearUserCookie = function () {};
      })(window, document, window['_fs_namespace'], 'script', 'user');
    }

    return _this;
  }

  _createClass(FullStory, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      return false;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (!canUseDOM || !getWindowFullStory()) return false;
      getWindowFullStory().shutdown();
      delete getWindowFullStory();
    }
  }, {
    key: "render",
    value: function render() {
      return false;
    }
  }]);

  return FullStory;
}(_react.Component);

exports.default = FullStory;
FullStory.propTypes = {
  org: _propTypes.default.string.isRequired
};